Index: .hgignore
===================================================================
--- .hgignore	(revision 90)
+++ .hgignore	(revision 0)
@@ -1,9 +1,7 @@
 INSTALL
-MANIFEST
 Makefile.in
 aclocal.m4
 autom4te.cache
-compile
-configure$
+configure
 depcomp
 install-sh
@@ -12,7 +10,2 @@
 config.sub
 ltmain.sh
-m4/.*\.m4
-.*\.pyc
-build
-dist
-doc/html
Index: Makefile.am
===================================================================
--- Makefile.am	(revision 79)
+++ Makefile.am	(revision 0)
@@ -1,13 +1,1 @@
-SUBDIRS=src test doc
-
-ACLOCAL_AMFLAGS = -I m4
-
-EXTRA_DIST=bootstrap.sh \
-        buildall.config         \
-        buildall.sh             \
-        buildallhosts.sh        \
-        buildmsi.bat            \
-        mkalldist.sh            \
-        mkccclientdist.sh       \
-        mkplugindist.sh         \
-        setup.py
+SUBDIRS=src
Index: configure.ac
===================================================================
--- configure.ac	(revision 109)
+++ configure.ac	(revision 0)
@@ -1,8 +1,8 @@
-AC_INIT(xplra, 0.3, ivaradi@gmail.com)
-AM_INIT_AUTOMAKE([foreign no-exeext])
+AC_INIT(xplra, 0.1, ivaradi@gmail.com)
+AM_INIT_AUTOMAKE([foreign])
 
 LT_INIT
-AC_CONFIG_MACRO_DIR([m4])
 
+AM_PROG_AS
 AC_PROG_CC
 AC_PROG_CXX
@@ -10,24 +10,48 @@
 PKG_PROG_PKG_CONFIG
 
-AM_VSCPL_TARGET_API
+AC_CHECK_HEADERS([windows.h winsock2.h])
+
+test "$ac_cv_header_windows_h" = "yes" -a "$ac_cv_header_winsock2_h" = "yes"
+_target_win32=$?
+
+AM_CONDITIONAL([TARGET_API_WIN32], test $_target_win32 -eq 0)
+AM_CONDITIONAL([TARGET_API_POSIX], test $_target_win32 -ne 0)
+if test $_target_win32 -eq 0; then
+   AC_DEFINE([TARGET_API_WIN32], [1], [Define if the target is the Win32 API.])
+else
+   AC_DEFINE([TARGET_API_POSIX], [1], [Define if the target is the POSIX API.])
+fi
+
+AC_MSG_CHECKING([where to find the X-Plane Plugin SDK])
+AC_ARG_WITH(xpsdk,
+            AC_HELP_STRING([--with-xpsdk=DIR],
+                           [use the X-Plane Plugin SDK in DIR]),
+            [
+                if test -r $withval/CHeaders/XPLM/XPLMPlugin.h; then
+                    AC_MSG_RESULT([$withval])
+                    XPSDK_INCLUDES="-I$withval/CHeaders/XPLM -I$withval/CHeaders/Wrappers -I$withval/CHeaders/Widgets"
+                    if test $_target_win32 -eq 0; then
+                        XPSDK_LDFLAGS="-L$withval/Libraries/Win"
+                    else
+                        XPSDK_LDFLAGS=""
+                    fi
+                else
+                    AC_MSG_FAILURE([not found in $withval])
+                fi
+            ],
+            [
+                 AC_MSG_FAILURE([please, specify])
+            ])
 
 AC_SUBST(XPSDK_INCLUDES)
 AC_SUBST(XPSDK_LDFLAGS)
 
-AM_VSCPL
+PKG_CHECK_MODULES([LIBXPLCOMMON], [libxplcommon >= 0.1])
 
 AC_CONFIG_FILES([
         Makefile
         src/Makefile
-        src/client/Makefile
-        src/client/c/Makefile
-        src/client/c/hu/Makefile
-        src/client/c/hu/varadiistvan/Makefile
-        src/client/c/hu/varadiistvan/xplra/Makefile
-        test/Makefile
-        doc/Makefile
+        src/xplra/Makefile
 ])
 
-AC_CONFIG_SUBDIRS([src/plugin])
-
 AC_OUTPUT()
Index: src/Makefile.am
===================================================================
--- src/Makefile.am	(revision 13)
+++ src/Makefile.am	(revision 0)
@@ -1,1 +1,1 @@
-SUBDIRS=plugin client
+SUBDIRS=xplra
Index: src/xplra/.copyright
===================================================================
--- src/xplra/.copyright	(revision 0)
+++ src/xplra/.copyright	(revision 0)
@@ -0,0 +1,23 @@
+// Redistribution and use in source and binary forms, with or without
+// modification, are permitted provided that the following conditions are met:
+
+// 1. Redistributions of source code must retain the above copyright notice, this
+//    list of conditions and the following disclaimer.
+// 2. Redistributions in binary form must reproduce the above copyright notice,
+//    this list of conditions and the following disclaimer in the documentation
+//    and/or other materials provided with the distribution.
+
+// THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
+// ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
+// WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
+// DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
+// ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
+// (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
+// LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
+// ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+// (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
+// SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+// The views and conclusions contained in the software and documentation are those
+// of the authors and should not be interpreted as representing official policies,
+// either expressed or implied, of the FreeBSD Project.
Index: src/xplra/.namespace
===================================================================
--- src/xplra/.namespace	(revision 0)
+++ src/xplra/.namespace	(revision 0)
@@ -0,0 +1,1 @@
+xplra
Index: src/xplra/.srcmessage
===================================================================
--- src/xplra/.srcmessage	(revision 0)
+++ src/xplra/.srcmessage	(revision 0)
@@ -0,0 +1,1 @@
+// This file is part of XPLRA, a remote-access plugin for X-Plane
Index: src/xplra/ListenThread.cc
===================================================================
--- src/xplra/ListenThread.cc	(revision 0)
+++ src/xplra/ListenThread.cc	(revision 0)
@@ -0,0 +1,58 @@
+// Copyright (c) 2013 by István Váradi
+
+// This file is part of XPLRA, a remote-access plugin for X-Plane
+
+// Redistribution and use in source and binary forms, with or without
+// modification, are permitted provided that the following conditions are met:
+
+// 1. Redistributions of source code must retain the above copyright notice, this
+//    list of conditions and the following disclaimer.
+// 2. Redistributions in binary form must reproduce the above copyright notice,
+//    this list of conditions and the following disclaimer in the documentation
+//    and/or other materials provided with the distribution.
+
+// THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
+// ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
+// WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
+// DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
+// ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
+// (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
+// LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
+// ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+// (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
+// SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+// The views and conclusions contained in the software and documentation are those
+// of the authors and should not be interpreted as representing official policies,
+// either expressed or implied, of the FreeBSD Project.
+
+//------------------------------------------------------------------------------
+
+#include "ListenThread.h"
+
+#include <XPLMUtilities.h>
+
+//------------------------------------------------------------------------------
+
+using xplra::ListenThread;
+
+//------------------------------------------------------------------------------
+
+void ListenThread::run()
+{
+    XPLMDebugString("xplra::ListenThread::run: started\n");
+
+    while(!quitEvent.check() && !quitEvent.failed()) {
+        waiter.wait();
+    }
+
+    XPLMDebugString("xplra::ListenThread::run: quitting\n");
+}
+
+//------------------------------------------------------------------------------
+
+// Local Variables:
+// mode: C++
+// c-basic-offset: 4
+// indent-tabs-mode: nil
+// End:
Index: src/xplra/ListenThread.h
===================================================================
--- src/xplra/ListenThread.h	(revision 0)
+++ src/xplra/ListenThread.h	(revision 0)
@@ -0,0 +1,108 @@
+// Copyright (c) 2013 by István Váradi
+
+// This file is part of XPLRA, a remote-access plugin for X-Plane
+
+// Redistribution and use in source and binary forms, with or without
+// modification, are permitted provided that the following conditions are met:
+
+// 1. Redistributions of source code must retain the above copyright notice, this
+//    list of conditions and the following disclaimer.
+// 2. Redistributions in binary form must reproduce the above copyright notice,
+//    this list of conditions and the following disclaimer in the documentation
+//    and/or other materials provided with the distribution.
+
+// THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
+// ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
+// WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
+// DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
+// ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
+// (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
+// LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
+// ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+// (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
+// SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+// The views and conclusions contained in the software and documentation are those
+// of the authors and should not be interpreted as representing official policies,
+// either expressed or implied, of the FreeBSD Project.
+
+#ifndef XPLRA_LISTENTHREAD_H
+#define XPLRA_LISTENTHREAD_H
+//------------------------------------------------------------------------------
+
+#include <xplcommon/Thread.h>
+#include <xplcommon/Waiter.h>
+#include <xplcommon/WaitableEvent.h>
+
+//------------------------------------------------------------------------------
+
+namespace xplra {
+
+//------------------------------------------------------------------------------
+
+/**
+ * The thread that listens to incoming connections and starts the
+ * client serving threads.
+ *
+ * This is a detached thread, to allow it to quit automatically.
+ */
+class ListenThread : public xplcommon::Thread
+{
+private:
+    /**
+     * The waiter used in the thread.
+     */
+    xplcommon::Waiter waiter;
+
+    /**
+     * The event that can be fired to notify the thread that it should
+     * quit.
+     */
+    xplcommon::WaitableEvent quitEvent;
+
+public:
+    /**
+     * Construct the thread.
+     */
+    ListenThread();
+
+    /**
+     * Notify the thread to quit.
+     */
+    void quit();
+
+    /**
+     * Perform the thread's operation.
+     */
+    virtual void run();
+};
+
+//------------------------------------------------------------------------------
+// Inline definitions
+//------------------------------------------------------------------------------
+
+inline ListenThread::ListenThread() :
+    Thread(true),
+    quitEvent(&waiter)
+{
+}
+
+//------------------------------------------------------------------------------
+
+inline void ListenThread::quit()
+{
+    quitEvent.fire();
+}
+
+//------------------------------------------------------------------------------
+
+} /* namespace xplra */
+
+//------------------------------------------------------------------------------
+#endif // XPLRA_LISTENTHREAD_H
+
+// Local Variables:
+// mode: C++
+// c-basic-offset: 4
+// indent-tabs-mode: nil
+// End:
Index: src/xplra/Makefile.am
===================================================================
--- src/xplra/Makefile.am	(revision 0)
+++ src/xplra/Makefile.am	(revision 0)
@@ -0,0 +1,24 @@
+INCLUDES=@XPSDK_INCLUDES@
+
+AM_CXXFLAGS=$(LIBXPLCOMMON_CFLAGS)
+
+if TARGET_API_WIN32
+AM_CPPFLAGS=-DIBM
+AM_LDFLAGS=@XPSDK_LDFLAGS@ -lXPLM -no-undefined
+endif
+
+if TARGET_API_POSIX
+AM_CPPFLAGS=-DLIN
+AM_CXXFLAGS+=-fPIC -fno-stack-protector
+endif
+
+lib_LTLIBRARIES=libxplra.la
+
+libxplra_la_SOURCES= \
+	plugin.cc	\
+	ListenThread.cc
+
+libxplra_la_LIBADD=$(LIBXPLCOMMON_LIBS)
+
+noinst_HEADERS= \
+	ListenThread.h
Index: src/xplra/plugin.cc
===================================================================
--- src/xplra/plugin.cc	(revision 0)
+++ src/xplra/plugin.cc	(revision 0)
@@ -0,0 +1,83 @@
+#include "ListenThread.h"
+
+#include <XPLMDefs.h>
+#include <XPLMUtilities.h>
+#include <XPLMProcessing.h>
+
+#include <cstdio>
+#include <cstring>
+#include <cstdarg>
+
+//------------------------------------------------------------------------------
+
+using xplra::ListenThread;
+
+//------------------------------------------------------------------------------
+
+static ListenThread* listenThread = 0;
+
+//------------------------------------------------------------------------------
+
+static void debug(const char* format, ...)
+{
+    va_list ap;
+    va_start(ap, format);
+
+    char buf[256];
+    vsnprintf(buf, sizeof(buf), format, ap);
+
+    va_end(ap);
+
+    XPLMDebugString(buf);
+}
+
+PLUGIN_API int XPluginStart(char* outName, char* outSignature,
+                            char* outDescription)
+{
+    debug("hu.varadiistvan.xplra called\n");
+
+    strcpy(outName, "X-Plane Remote Access");
+    strcpy(outSignature, "hu.varadiistvan.xplra");
+    strcpy(outDescription, "Provides remote access to datarefs");
+
+    return 1;
+}
+
+// float callback(float elapsedSinceLastCall, float elapsedTimeSinceLastFlightLoop,
+//               int counter, void* refcon)
+// {
+//     debug("hu.varadiistvan.proba.callback called: elapsedSinceLastCall=%f, elapsedTimeSinceLastFlightLoop=%f, counter=%d, refcon=%p\n",
+//           elapsedSinceLastCall, elapsedTimeSinceLastFlightLoop,
+//           counter, refcon);
+//     return 5.0;
+// }
+
+PLUGIN_API void XPluginEnable(void)
+{
+    debug("hu.varadiistvan.proba.XPluginEnable called\n");
+    // XPLMRegisterFlightLoopCallback(&callback, 5.0, 0);
+    listenThread = new ListenThread();
+    listenThread->start();
+}
+
+PLUGIN_API void XPluginReceiveMessage(XPLMPluginID inFrom, long inMessage,
+                                      void* inParam)
+{
+    debug("hu.varadiistvan.proba.XPluginReceiveMessage called, inFrom=%d, inMessage=%ld, inParam=%p\n",
+          inFrom, inMessage, inParam);
+}
+
+PLUGIN_API void XPluginDisable(void)
+{
+    debug("hu.varadiistvan.proba.XPluginDisable called\n");
+    // XPLMUnregisterFlightLoopCallback(&callback, 0);
+    if (listenThread!=0) {
+        listenThread->quit();
+        listenThread = 0;
+    }
+}
+
+PLUGIN_API void XPluginStop(void)
+{
+    debug("hu.varadiistvan.proba.XPluginStop called\n");
+}
